# plugin api
import plugin
import subprocess

import cyrusUtil

class CyrusFolderPlugin(plugin.Plugin):
        def configure(self,conf):
                self.baseDn=conf.get("cyrusFolder","baseDn")
                self.folderPrefix=conf.get("cyrusFolder","folderPrefix")
                self.folderSuffix=conf.get("cyrusFolder","folderSuffix")
                self.addressPrefix=conf.get("cyrusFolder","addressPrefix")
                self.folderAdmin=conf.get("cyrusFolder","folderAdmin")
                self.folderPermissions=conf.get("cyrusFolder","folderPermissions")
                self.destAttr=conf.get("cyrusFolder","attribute")
                self.cyrusUser=conf.get("cyrus","username")
                self.cyrusPassword=conf.get("cyrus","password")
                self.cyrusServer=conf.get("cyrus","imapServer")
        def create(self,dn,attrs):
                self.update(dn,attrs)

        def update(self,dn,attrs):
                if not self.filter(dn):
                        return

                username = self.getUsername(dn)
                if attrs.has_key(self.destAttr):
                        for v in attrs[self.destAttr]:
                                if v.startswith(self.addressPrefix):
                                        folder=v[len(self.addressPrefix):]
                                        self.createSharedFolder(self.folderPrefix+folder+self.folderSuffix)

        def delete(self,dn):
                return

        def rename(self,dn,attrs,dn2):
                if not self.filter(dn):
                        return

        def exists(self,dn,attrs):
                return False

        def cyrusConnect(self):
                self.session = cyrusUtil.login(self.cyrusServer,self.cyrusUser,self.cyrusPassword)
               
        def cyrusDisconnect(self):
                self.session.logout()

        def createSharedFolder(self,name):
                print "CyrusFolderPlugin.createSharedFolder",name
                self.cyrusConnect()
                result=self.session.list(name)
                if result!=None and len(result)>1 and result[1]!=[None]:
                        print " folder exists"
                        pass
                else:
                        r=self.session.create(name)
                        if r[0]=='NO':
                                print " createmailbox:",r
                        r=self.session.setacl(name,"anyone","lrsp")
                        if r[0]=='NO':
                                print " setacl:",r
                        r=self.session.setacl(name, self.folderAdmin, self.folderPermissions)
                        if r[0]=='NO':
                                print " setacl:",r

                self.cyrusDisconnect()
