# plugin api
import plugin
import subprocess

class DnsDhcpPlugin(plugin.Plugin):
        def configure(self,configuration):
                section="DnsDhcp"
                self.baseDn=configuration.get(section,"computersDn").lower()
                self.baseDn2=configuration.get(section,"devicesDn").lower()
                self.command=configuration.get(section,"command")

        def create(self,dn,attrs):
                self.update(dn,attrs)

        def update(self,dn,attrs):
                if not self.filter(dn,attrs):
                        return
                self.runCommand()

        def delete(self,dn):
                self.update(dn,None)

        def rename(self,dn,attrs,dn2):
                self.update(dn,attrs)

        def exists(self,dn,attrs):
                return False

        def runCommand(self):
                subprocess.check_call(self.command,shell=True)

        def filter(self,dn,attrs):
                lowerdn = dn.lower()
                if lowerdn.endswith(self.baseDn) or lowerdn.endswith(self.baseDn2):
                        return True
                else:
                        return False
