# plugin api
import plugin
import subprocess

class DovecotPlugin(plugin.Plugin):
        def __init__(self):
                self.baseDn='ou=users,dc=example,dc=com'
                self.nameAttr='uid'
                self.basedir='/tmp/dovecot'
                self.commandPrefix="sh -c "

        def configure(self,conf):
                self.baseDn=conf.get("dovecot","baseDn")
                self.basedir=conf.get("dovecot","baseDir")
                self.commandPrefix=conf.get("dovecot","commandPrefix")+" "

        def create(self,dn,attrs):
                pass

        def update(self,dn,attrs):
                pass

        def delete(self,dn):
                if not self.filter(dn):
                        return

                username = self.getUsername(dn)
                self.command("\"rm -rf %s/%s\"" % (self.basedir,username))

        def rename(self,dn,attrs,dn2):
                if not self.filter(dn):
                        return

                oldUsername=self.getUsername(dn2)
                newUsername=self.getUsername(dn)
                self.command(" \"/opt/dass-it/scripts/dovecotUtil.py renameUser %s %s\"" %
                 (oldUsername,newUsername))

        def exists(self,dn,attrs):
                return False

        def command(self,cmd):
                print cmd
                subprocess.call(self.commandPrefix+cmd,shell=True)
