# plugin api
import plugin
import subprocess

class SambaPlugin(plugin.Plugin):
        def __init__(self):
                self.baseDn='ou=users,dc=example,dc=com'
                self.nameAttr='uid'
                self.basedir='/tmp/samba'
                self.netlogonDir='/tmp/profiles'
                self.commandPrefix="sh -c "
                self.deleteHome=True

        def configure(self,conf):
                self.baseDn=conf.get("samba","baseDn")
                self.basedir=conf.get("samba","baseDir")
                self.commandPrefix=conf.get("samba","commandPrefix")+" "
                self.netlogonDir=conf.get("samba","netlogonDir")
                        
        def create(self,dn,attrs):
                if not self.filter(dn,attrs):
                        return
                username = self.getUsername(dn)
                self.command("\"mkdir %s/%s;chown %s: %s/%s\""
                        % (self.basedir,username,username,self.basedir,username))

        def update(self,dn,attrs):
                if not self.filter(dn,attrs):
                        return
                username = self.getUsername(dn)

        def delete(self,dn):
                if not self.filter(dn,None):
                        return
                username = self.getUsername(dn)
                if username=="" or ".." in username or "/" in username:
                        raise Exception("invalid username")

                if self.deleteHome==True:
                        self.command("\"rm -rf %s/%s\"" % (self.basedir,username))

        def rename(self,dn,attrs,dn2):
                if not self.filter(dn,attrs):
                        return
                oldUsername=self.getUsername(dn2)
                newUsername=self.getUsername(dn)
                self.command("\"mv %s/%s %s/%s;mv %s/%s.cmd %s/%s.cmd\"" %
                 (self.basedir,oldUsername,self.basedir,newUsername,
                        self.netlogonDir,oldUsername,self.netlogonDir,newUsername))

        def exists(self,dn,attrs):
                username=self.getUsername(dn)
                try:
                        subprocess.check_call(self.commandPrefix+"\"test -d %s/%s\""
                          % (self.basedir,username),shell=True)
                except subprocess.CalledProcessError:
                        return False

                return True

        def getUsername(self,dn):
                i=dn.find(',')
                rdn=dn[:i].lower()
                rest=dn[i+1:].lower()
                if rest!=self.baseDn.lower():
                        return None

                username=rdn.split("=")[1]
               
                return username

        def command(self,cmd):
                # print cmd
                subprocess.call(self.commandPrefix+cmd,shell=True)
