#!/usr/bin/python
# coding: utf8

import os
import signal
import sys
import ConfigParser
import httplib,urllib
import base64
import random
import string
import getpass
import time

configPath="/opt/dass-it/etc/dassadmin-passwd.conf"

connection=None
configuration=None
baseDn=None
webserver="localhost"
httpUser="admin"
httpPassword="password"
authHash=""
passwordLength=8

debug=False

def setPassword(username,pwd):
        entry = {}
        entry['key']=username
        entry['pwd1']=pwd
        entry['pwd2']=pwd
        entry['save']='true'
        entry['sambaHack']='true'
        status,data = postRequest("setpassword-action.vm",entry) 
        if debug:
               print status,data
        if status==302 and "error=" in data:
               status=9999
        return status

def postRequest(url,entry):
        params=urllib.urlencode(entry)
        headers = {"Content-type": "application/x-www-form-urlencoded",
                   "Accept": "text/html;text/plain",
                   "Authorization" : "Basic %s" % authHash}
        c = httplib.HTTPSConnection(webserver)
        if debug:
                print "HTTP POST /dassadmin/users/"+url
                print params
        c.request("POST", "/dassadmin/users/"+url, params, headers)
        response = c.getresponse()
        if response.status==302:
                data = response.getheader('Location')
        else:
                data = response.read()
        c.close()
        return (response.status,data)

def log(username,result):
        logfile=open("/tmp/dassadmin-passwd.log","a")
        logfile.write(username+" "+result+"\n")
        logfile.close()

def go_into_background():
        pid = os.fork()
        if pid != 0:
                # parent
		time.sleep(1)
                os._exit(0)
        else:
                log("fork","-")
		signal.signal(signal.SIGHUP,signal.SIG_IGN)
                log("signal","-")
                sys.stdin.close()
                os.close(0)
                os.close(1)
                os.close(2)
                sys.stdin=open("/dev/null","w+")
                sys.stdout=open("/dev/null","w+")
                sys.stderr=open("/dev/null","w+")

if __name__ == "__main__":
        log("start","-")
        configuration = ConfigParser.ConfigParser()
        configuration.read(configPath)

        webserver=configuration.get("webservice","server")
        httpUser=configuration.get("webservice","username")
        httpPassword=configuration.get("webservice","password")

        authHash = base64.encodestring('%s:%s' % (httpUser, httpPassword))[:-1]

        username=sys.argv[1]
        password=getpass.getpass("New password:")
        password2=getpass.getpass("Retype new password:")

        if len(sys.argv)>2 and sys.argv[2]=='debug':
                debug=True 
        if not password==password2:
                print "Passwords do not match."
                log(username,"passwords do not match")
                sys.exit(1)

        print "Password changed."

        go_into_background()

        log("sleep","-")
        time.sleep(5)

        log("setPassword",username)
        result=setPassword(username,password)

        log(username,str(result))

        if int(result)>=400:
                # print "Error changing password via webservice (%d)" % (result)
                sys.exit(2)

        sys.exit(0)
