#!/usr/bin/python

import os
import re
import sys
import subprocess

basedir="/storage/vmail"


def treewalk(basedir,function):
        for base, dirs, files in os.walk(basedir):
                if "dovecot-acl" in files:
                        function(os.path.join(base,"dovecot-acl"))

def scanAcl(path,dict):
        myname=path[len(basedir)+1:].split('/')[0]
	username=None
        f=open(path,"r")
        for l in f.readlines():
                if l.startswith('user='):
                        cols=l.split(' ')
                        username=cols[0][5:]
                        if username == None:
                                print "ERROR: no username",path,l
                                return
                        dict[username+'/'+myname]='1'

def createDatabase(dbfile):
	sql="""CREATE TABLE anyone_shares ( from_user varchar(100) not null, dummy char(1), primary key(from_user));
CREATE TABLE user_shares (
  from_user varchar(100) not null,
  to_user varchar(100) not null,
  dummy char(1),        -- always '1' currently
  id integer primary key 
);
"""
        subprocess.call([ "sqlite3", dbfile+".sqlite", sql ])

def makeSharedDict():
        shared_users_dict={}

        treewalk(basedir, lambda f: scanAcl(f,shared_users_dict))
        for k in shared_users_dict.keys():
                to_user,from_user=k.split('/')
		if to_user!=from_user:
                	print "INSERT INTO user_shares VALUES ('%s','%s','1');" % ( from_user, to_user)

def makeSharedDictFile():
        shared_users_dict={}

        treewalk(basedir, lambda f: scanAcl(f,shared_users_dict))

        for k in shared_users_dict.keys():
                to_user,from_user=k.split('/')
		if to_user!=from_user:
                	print "shared/shared-boxes/user/%s/%s\n1" % ( to_user, from_user)

def replaceUserInAcl(path,oldUser,newUser):
        f=open(path,"r+")
        buffer=f.read()
        new=buffer.replace("user="+oldUser+" ","user="+newUser+" ")
        if not new == buffer:
        	print path,oldUser,newUser
                f.seek(0)
                f.truncate(0)
                f.write(new)
        f.close()

def fixSharedMailboxesOld(path,oldUser,newUser):
        oldUser=re.escape(oldUser)
        newUser=re.escape(newUser)
        f=open(path,"r+")
        buffer=f.read()
        e1='/'+oldUser+'/'
        e2='/'+oldUser+r'\n'

        new=re.sub(e1,r'/'+newUser+r'/',buffer)
        new=re.sub(e2,r'/'+newUser+'\n',new)

        if not new == buffer:
                f.seek(0)
                f.truncate(0)
                f.write(new)
        f.close()

def fixSharedMailboxes(path,oldUser,newUser):
        subprocess.call([ "sqlite3", path+".sqlite", "UPDATE user_shares SET from_user='%s' WHERE from_user='%s';" % (newUser,oldUser) ])
        subprocess.call([ "sqlite3", path+".sqlite", "UPDATE user_shares SET to_user='%s' WHERE to_user='%s';" % (newUser,oldUser) ])

def replaceGroupInAcl(path,oldGroup,newGroup):
        print path,oldGroup,newGroup
        f=open(path,"r+")
        buffer=f.read()
        new=buffer.replace("group="+oldGroup+" ","group="+newGroup+" ")
        if not new == buffer:
                f.seek(0)
                f.truncate(0)
                f.write(new)
        f.close()

if __name__ == "__main__":
        command=sys.argv[1]

        if command == "renameUser":
                oldUser=sys.argv[2]
                newUser=sys.argv[3]

                oldDir=os.path.join(basedir,oldUser)
                newDir=os.path.join(basedir,newUser)

                if not os.path.exists(oldDir):
                        sys.exit(0)

                os.rename(oldDir,newDir)
		sys.exit(0)
                treewalk(basedir,lambda f: replaceUserInAcl(f,oldUser,newUser))
                fixSharedMailboxesOld(os.path.join(basedir,'.db/shared-mailboxes'),oldUser,newUser)

        elif command == "renameGroup":
                oldUser=sys.argv[2]
                newUser=sys.argv[3]
		
		sys.exit(0)
                oldGroup=oldUser
                newGroup=newUser
                treewalk(basedir,lambda f: replaceGroupInAcl(f,oldGroup,newGroup))

        elif command == "makeSharedDict":
                makeSharedDict() 
        elif command == "makeSharedDictFile":
                makeSharedDictFile() 
        elif command == "createDatabase":
                createDatabase(os.path.join(basedir,'.shared-mailboxes')) 
        else:
                print "valid commands are: renameUser, renameGroup, makeSharedDict, makeSharedDictFile, createDatabase"
                sys.exit(1)
