#!/usr/bin/python
import fcntl
import os
import sys

queueDir='/var/spool/dassadmin'
queueLockfile='lock'

def queueJob(message):
        f=open(os.path.join(queueDir,queueLockfile),'r+')
        fcntl.lockf(f,fcntl.LOCK_EX)
        lastJobNumber=int(f.readline())

        newJobNumber=str(lastJobNumber+1)
        jobFile=os.path.join(queueDir,newJobNumber)

        j=open(jobFile,"w")
        j.write(message)
        j.close()

        f.seek(0)
        f.write(newJobNumber)
        fcntl.lockf(f,fcntl.LOCK_UN) 
        f.close()

def dequeueJob():
        message=None
        f=None
        try:
                f=open(os.path.join(queueDir,queueLockfile),'r+')
                fcntl.lockf(f,fcntl.LOCK_EX)
                lastJobNumber=int(f.readline())
                message = readAndDeleteJob(lastJobNumber)
        except:
                print "Error reading job queue"
        finally:
                if f!=None:
                        fcntl.lockf(f,fcntl.LOCK_UN) 
                        f.close()

	return message

def readAndDeleteJob(lastJobNumber):
        filelist = os.listdir(queueDir)
        lowestJobNumber=lastJobNumber

        jobCount=0

        for file in filelist:
                if file == queueLockfile:
                        continue
                try:
                        i=int(file)
                        jobCount=jobCount+1
                        if i<lowestJobNumber:
                                lowestJobNumber=i

                except ValueError:
                        pass
        if jobCount==0:
                return None

        jobFileName=os.path.join(queueDir,str(lowestJobNumber))
        f=open(jobFileName,'r')
        job=f.readlines()
        f.close()
        
        os.remove(jobFileName)

        return job

if __name__ == '__main__':
        if len(sys.argv) > 1:
		message = '\n'.join(sys.argv[1:]) + '\n'
		queueJob(message)
        else:
        	dequeueJob()
