# plugin api

def getConfig(configParser, section, name, default=None):
        try:
                return configParser.get(section,name)
        except:
                return default


class Plugin(object):
        def configure(self,configuration):
                pass

        def log(self,msg):
                print type(self).__name__,msg

        def create(self,dn,attrs):
                raise Exception("must be implemented by subclass")

        def update(self,dn,attrs):
                raise Exception("must be implemented by subclass")

        def delete(self,dn):
                raise Exception("must be implemented by subclass")

        def rename(self,dn,attrs,oldDn):
                raise Exception("must be implemented by subclass")

        def exists(self,dn,attrs):
                raise Exception("must be implemented by subclass")

        def getUsername(self,dn):
                i=dn.find(',')
                rdn=dn[:i].lower()
                rest=dn[i+1:].lower()
                if rest!=self.baseDn.lower():
                        return None
                username=rdn.split("=")[1]
                if username==None or username=="":
                        raise Exception("empty username")

                forbidden=[ "..", "/", "$",";","`","\"","\\" ]
                
                for f in forbidden:
                        if f in username:
                                raise Exception("invalid username")
                return username

        def getName(self,dn):
                i=dn.find(',')
                rdn=dn[:i].strip()
                rest=dn[i+1:].strip()
                if not rest.lower().endswith(self.baseDn.lower()):
                        return None
                name=rdn.split("=")[1]
                if name==None or name=="":
                        raise Exception("empty username")

                forbidden=[ "..", "/", "$",";","`","\"","\\" ]

                for f in forbidden:
                        if f in name:
                                raise Exception("invalid name")
                return name


        def filter(self,dn,attrs=None):
                if dn.lower().endswith(self.baseDn.lower()):
                        return True
                else:
                        return False
